require 'cudnn'

if not opt then
   cmd = torch.CmdLine()
   cmd:text()
   cmd:text('Dataset Preprocessing')
   cmd:text()
   cmd:text('Options:')
   cmd:option('-measure','PKR','Input network name')
   cmd:text()
   opt = cmd:parse(arg or {})
end

cpu = torch.load('NETS/cpu/'..opt.measure..'.net')
gpu = nn.Sequential()

for i=0,6 do
	ninput = cpu.modules[i*2+1].weight:size()[2]
	noutput = cpu.modules[i*2+1].weight:size()[1]
	k = cpu.modules[i*2+1].weight:size()[3]

	gpu:add(cudnn.SpatialConvolution(ninput, noutput, k, k))
	if i <6 then 
		gpu:add(cudnn.ReLU())
	else
		gpu:add(cudnn.Sigmoid())
	end

	gpu.modules[i*2+1].bias = cpu.modules[i*2+1].bias:cuda() 
	gpu.modules[i*2+1].weight = cpu.modules[i*2+1].weight:cuda() 
end

torch.save('NETS/gpu/'..opt.measure..'.net', gpu)

